indexing

   title:       "VECTOR_FORMATTER";
   cluster:     "format/science/examples/vector [format/science/examples/vector]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Andy Malakov  (andy@eiffel.ru) and";
   original:    08,Sep,1995;
   version:     1.0;
   last_change:
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "vect_fmt.e"

class VECTOR_FORMATTER

   inherit
      ABSTRACT_JUSTIFY_FORMATTER
         redefine
            make, set_sign, set_align_char, output
         end;

   creation
      make

   feature

      joker : FIXED_POINT_FORMATTER
      vect : ARRAY [ REAL ]
      signs, align_chars : STRING

      ------------------------------------------------------------ make
      make ( v : ARRAY [ REAL ] ) is
         require else v /= Void
         do
            vect := v
            abstract_justify_make ( v )
            !!joker.make( 3.1415934563 ) -- forgot it
            !!signs.make (0)
            !!align_chars.make (0)
         end
      ----------------------------------------------------------- set_sign
      set_sign ( c : CHARACTER ) is
         do
            --signs.extend ( c )
            str_tools.x_extend ( signs, c )
         end
      ----------------------------------------------------------- set_align_char
      set_align_char ( c : CHARACTER ) is
         do
            --align_chars.extend ( c )
            str_tools.x_extend ( align_chars, c )
         end
      ------------------------------------------------------------ output
      output : STRING is
         local
            i, j : INTEGER
         do
            !!Result.make (0)
            str_tools.x_extend (Result,'{')
            from i := vect.lower until i > vect.upper loop

               if i > vect.lower then str_tools.x_append (Result,", ") end

               joker.make ( vect @ i )
               from j := 1 until j > signs.count loop
                  joker.set_sign ( signs @ j)
                  j := j + 1
               end
               from j := 1 until j > align_chars.count loop
                  joker.set_align_char ( align_chars @ j)
                  j := j + 1
               end
               joker.set_width ( width )
               joker.set_precision ( prec )
               str_tools.x_append ( Result, joker.output )
               i := i + 1
            end -- loop
            str_tools.x_extend (Result,'}')
         end -- output

      ------------------------------------------------------------ str_tools
      str_tools : STRING_TOOLS is once !!Result end

end -- class VECTOR_FORMATTER
