indexing

   title:       "Real commercial formatter class";
   cluster:     "format/commerce [format/commerce]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "real_com.e"

class REAL_COMMERCIAL_FORMATTER

inherit
   ABSTRACT_COMMERCIAL_FORMATTER
      redefine make, output, set_currency, set_point, set_delimiters
   end
   EXTENDED_MATH
   STRING_TOOLS

creation
   make

feature

   make (r : REAL_REF) is
      do
         sign := real_sign(r.item)
         num := abs(r.item)
         point := '.'
         currency := '$'
         delimiters := ""
      end

   set_point(c : CHARACTER) is
   require else
      Point_Not_Null : c /= '%U'
      do
         point := c
      end

   set_delimiters(s : STRING) is
      do
         x_adapt(delimiters,s)
      end


   set_currency(s : STRING) is
   require else
      String_Not_Void : s /= Void
      do
         currency := s.item(1)
      end

--   set_blank_when_zero is
--   set_justified_right is
--   set_justified_left is
--   set_upper_character is
--   set_lower_character is
--   set_sign_leading is
--   set_sign_trailing is
--   set_sign_leading_separate is
--   set_sign_trailing_separate is

   output : STRING is
   require else
      Non_void_picture : picture /= Void
      local
         icf : INTEGER_COMMERCIAL_FORMATTER
         i,j : INTEGER
         int, frac : STRING
         anum, fracnum : REAL
      do
         i := index(picture,'.')
         if i = 0 then
            !!icf.make(floor(abs(num))*real_sign(num))
            icf.set_picture(picture)
            Result := icf.output
         else
            int := picture.substring(1,i-1)
            frac := picture.substring(i+1,picture.count)
            check_frac(frac)
            from
               i := 0
               j := 1
            until
               j > frac.count
            loop
               if frac.item(j) = '9' then
                  i := i + 1
               end
               j := j + 1
            end
            anum := abs(num)
            fracnum := anum - floor(anum)
            !!icf.make(floor((fracnum*ten_power(i)+0.5)*real_sign(num)))
            icf.set_picture(frac)
            !!Result.make(0)
            x_append(Result,icf.output)
            Result.precede(point)
            !!icf.make(floor(abs(num))*real_sign(num))
            icf.set_picture(int)
            Result.prepend(icf.output)
         end
      end

feature {NONE}

   num : REAL
   sign : INTEGER
   point : CHARACTER
   currency : CHARACTER
   delimiters : STRING

   -- routines for fractional part
   check_frac( pic : STRING) is
      local
         i : INTEGER
         no_more_sign, no_more_dollar, is_last_char : BOOLEAN
      do
         no_more_sign := False
         no_more_dollar := False
         is_last_char := True
         from
            i := pic.count
         until
            i < 1
         loop
            if pic.item(i) = '$' then
               if no_more_dollar then
                  raise_exception("Illegal place for dollar")
               end
               if is_last_char then
                  no_more_dollar := True
               else
                  raise_exception("Illegal place for dollar")
               end
            elseif contain("+-",pic.item(i)) then
               if no_more_dollar then
                  raise_exception("Illegal place for sign")
               end
               if is_last_char then
                  no_more_sign := True
               else
                  raise_exception("Illegal place for sign")
               end
            elseif pic.item(i) = '9' then
               no_more_sign := True
               no_more_dollar := True
               is_last_char := False
            else
               raise_exception("Illegal char in frac part")
            end
            i := i - 1
         end
      end

end -- class REAL_COMMERCIAL_FORMATTER
